#pragma once

#include <Figments.h>
#include "Config.h"
#include <map>

class Colors: public BufferedInputSource, ConfigTaskMixin {
  public:
    struct Sequence {
      String name;
      const std::vector<CRGB> colors;
    };

    Colors();
    void loop() override;
    void handleEvent(const InputEvent& evt) override;
    void handleConfigChange(const Configuration& cfg) override;
    const std::vector<Command>& commands() const override;

  private:
    uint16_t m_idx;
    uint16_t m_colorIdx;
    uint16_t m_colorTimer;
    uint16_t m_secondsPerColor;
    std::vector<Sequence> m_sequences;
    std::map<const char*, const char*> m_sceneMap;

    void setScene(const char* sceneName);
    void setSequence(const char* seqName);

    void doSequences(Args& args, Print& out);
    void doSequence(Args& args, Print& out);
    void doRotate(Args& args, Print& out);

    void rotate();
};
