#pragma once

#include <Figment.h>
#include <vector>
#include "Config.h"

class Sequencer: public Task, ConfigTaskMixin {
public:

    class Scene {
      public:
        String name;
        std::vector<String> patterns;
        void start();
        void stop();
    };

    Sequencer();

    void loop() override;
    void onStart() override;
    void handleEvent(const InputEvent& evt) override;
    void handleConfigChange(const Configuration& cfg) override;

    const char* currentSceneName();
    const std::vector<Scene> scenes() const;
    const std::vector<Command>& commands() const override;

private:
    int m_idx;
    int m_sceneBeforeIdle;
    bool m_hasStartupScene;
    std::vector<Scene> m_scenes;

    bool changeToScene(const char* name);

    void doScene(Args& args, Print& out);
    void doScenes(Args& args, Print& out);
};
