#include <Figments.h>

class TestAnimation: public Figment {
public:
    TestAnimation() : Figment("Test") {}
    void loop() override;
    void render(Display* dpy) const override;
    void handleEvent(const InputEvent& evt) override;
    const std::vector<Command>& commands() const override;

private:
    uint8_t m_x;
    uint8_t m_y;
    CRGB m_color;
    uint8_t m_hue;

    enum Mode {
      None,
      Raw,
      Outline,
      White,
      Red,
      Green,
      Blue,
      HSV,
      RGB,
      Top,
      Left,
      Right,
      Bottom
    };

    Mode m_mode = None;
    void doMode(Args&, Print&);
};
