#include <Figments.h>
#include "../Static.h"

class Thinking: public Figment {
  public:
    Thinking() : Figment("Thinking") {}
    void render(Display* dpy) const override {
      Surface sfc = Surface(dpy, {0, 0}, {255, 255});
      uint8_t noiseY = sin8(m_noiseOffset % 255);
      uint8_t noiseX = cos8(m_noiseOffset % 255);
      sfc.paintShader([=](CRGB& pixel, const VirtualCoordinates& coords, const PhysicalCoordinates, const VirtualCoordinates& surfaceCoords) {
          pixel = CHSV(inoise8(noiseX + surfaceCoords.x, noiseY + surfaceCoords.y), 255, inoise8(noiseY + surfaceCoords.y, noiseX + surfaceCoords.x));
      });
    }

    void loop() override {
      EVERY_N_MILLISECONDS(15) {
        m_noiseOffset += 1;
      }
    }
  private:
    int m_noiseOffset;
};

STATIC_ALLOC(Thinking);
STATIC_TASK(Thinking);
